!  Task callback functions for task delay and DDE receive.
!  Carl W. Sumner           05-20-99
!  Version 1.02    Last modified by  CWS  08-06-00

!Warning:  These procedures require that the Ask() method be imbedded to exit
!          on a Timer event or DDE event. The stock Ask() method will lock up
!          on these calls. The Run() method must be replaced with a Run() that calls
!          the procedure that will call here. These use the currently open thread window.


   MEMBER()                             ! This is a Utility module

   INCLUDE('ABWINDOW.INC'),ONCE
   INCLUDE('KEYCODES.CLW'),ONCE

                     MAP
                       INCLUDE('CLWCALL.INC'),ONCE        !Local module prodecure declarations
                       INCLUDE('dde.clw')
                     END


M2CcKey   BYTE,NAME('BRWINTMP@CcKey'),EXTERNAL
M2DoDisplay   BYTE,NAME('BRWINTMP@DoDisplay'),EXTERNAL
M2EscKey   BYTE,NAME('BRWINTMP@EscKey'),EXTERNAL
M2running   BYTE,NAME('BRWINTMP@running'),EXTERNAL
IO_AlertKeyCode   UNSIGNED,NAME('IO@AlertKeyCode'),EXTERNAL
IO_AlertKeyChar   UNSIGNED,NAME('IO@AlertKeyChar'),EXTERNAL

SaveDDEevent   BYTE,THREAD
LostDDEevent   SIGNED,THREAD
LostDDEchan   ULONG,THREAD

LostDDEvalue   CSTRING(770),THREAD   ! Set length by MAX_DATA_SIZE in BARLIB.DEF Modula-2 file.

QueChanErr EQUATE(7)
NoQueFound EQUATE(9)
QueInUse   EQUATE(10)
QueEmpty   EQUATE(14)
QueFull    EQUATE(15)
QShutDown  EQUATE(30)
QLostEvent EQUATE(32)
esc        EQUATE(27)
can        EQUATE(24)
DDEack     EQUATE(1)
DDEnak     EQUATE(0)


! Wait for a KeyPress to be received
! WAITKEY PROCEDURE(WindowManager), Name('CLWCALL$WAITKEY')
WAITKEY              PROCEDURE  (SELF)         ! Declare Procedure     08-05-00
  CODE
  IF IO_AlertKeyCode <> 0 THEN RETURN END  ! Already have one.
  0{Prop:Timer} = 0   ! Send fake timer event from main.    08-06-00
  SELF.Ask

  CASE EVENT()
  OF EVENT:AlertKey
    IO_AlertKeyCode = KEYCODE()
    IO_AlertKeyChar = KEYCHAR()
    IF KEYCODE() = F11Key THEN
      IO_AlertKeyCode = F1Key
      IO_AlertKeyChar = 0
    END
  OF EVENT:CloseWindow
    IO_AlertKeyCode = esc
  OF EVENT:CloseDown
    IO_AlertKeyCode = can
  OF EVENT:DDEexecute
    IF SaveDDEevent THEN
      IF LostDDEevent <> 0 THEN
        MESSAGE('Doubled DDE message lost in WAITKEY.')
      END
      LostDDEevent = EVENT()
      LostDDEchan = DDEchannel()
      LostDDEValue = DDEvalue()
      DDEacknowledge( DDEack )
    END
  ELSE
    MESSAGE('Lost message or other event in WAITKEY.' & EVENT())
  END



! Process delay for radio server
! TDELAY PROCEDURE(WindowManager, UNSIGNED), Name('CLWCALL$TDELAY')
TDELAY               PROCEDURE  (SELF, ticks)         ! Declare Procedure
  CODE
  0{Prop:Timer} = TICKS * 1.667 + 1
  SELF.Ask
  0{Prop:Timer} = 0

  CASE EVENT()
  OF EVENT:Timer
    ! ok
  OF EVENT:CloseWindow
    IO_AlertKeyCode = esc
  OF EVENT:CloseDown
    IO_AlertKeyCode = can
  OF EVENT:DDEexecute
    IF SaveDDEevent THEN
      IF LostDDEevent <> 0 THEN
        MESSAGE('Doubled DDE message lost in TDELAY.')
      END
      LostDDEevent = EVENT()
      LostDDEchan = DDEchannel()
      LostDDEValue = DDEvalue()
      DDEacknowledge( DDEack )
    END
  ELSE
    MESSAGE('Lost message or other event in TDELAY.' & EVENT())
  END


!  Conditional Read DDE server channel
! READDDE  FUNCTION(WindowManager, Byte, Ulong, *Cstring), UNSIGNED, Name('CLWCALL$READDDE')
READDDE              PROCEDURE  (SELF, DDEwait, Chan, Bufstr) ! Declare Procedure
Tchan Ulong

  CODE
 SaveDDEevent = true
 IF LostDDEevent = EVENT:DDEexecute THEN
   LostDDEevent = 0
   BufStr = LostDDEvalue
   Tchan = LostDDEchan
   IF Tchan <> Chan THEN
     RETURN QueChanErr
   ELSE
     RETURN 0
   END
 END
 IF DDEwait THEN
   0{Prop:Timer} = 0  ! No timer tick
 ELSE
   0{Prop:Timer} = 1  ! Quick timer tick
 END
 SELF.Ask
 0{Prop:Timer} = 0
 CASE EVENT()
 OF EVENT:DDEexecute
   BufStr = DDEvalue()
   Tchan = DDEchannel()
   DDEacknowledge( DDEack )
   IF Tchan <> Chan THEN
     RETURN QueChanErr
   ELSE
     RETURN 0
   END
 OF EVENT:Timer
  RETURN QueEmpty
 OF EVENT:CloseWindow
   IO_AlertKeyCode = esc; RETURN QueEmpty
 OF EVENT:CloseDown
   IO_AlertKeyCode = can; RETURN QShutDown
 ELSE
   MESSAGE('Lost message or other event in READDDE.' & EVENT())
   RETURN QLostEvent
 END

! end
