(* ------------------------------------------------------------ *)
(* ---                    M2SCROLL.MOD                      --- *)
(* ---   Interface to Clarion scrolling screen functions.   --- *)
(* ---   This version is for Clarion for Windows V5.0a      --- *)
(* ---   Uses the currently top window in thread.           --- *)
(* ---                                                      --- *)
(* ---   Version 1.05    Last modified by  CWS  07-06-00    --- *)
(* ------------------------------------------------------------ *)


(*#module(init_code => off) *)
(*#call (o_a_copy=>off)*)
IMPLEMENTATION MODULE M2SCROLL;


IMPORT Str, Lib, CWRUN;
FROM CWRUN IMPORT SIGNED;



 PROCEDURE PadStr(VAR StrBuff:ARRAY OF CHAR; Lnth:CARDINAL; chr:CHAR);
 VAR Psn,Aptr: CARDINAL;
 BEGIN
   Psn := Str.Length(StrBuff);  (* length of string *)
   IF Psn = Lnth THEN RETURN; END;
   IF Psn < Lnth THEN
     IF Lnth-1 > HIGH(StrBuff) THEN Lnth := HIGH(StrBuff)+1; END;
    (* Lib.Fill( ADR(StrBuff[Psn]), Lnth-Psn+1, chr); *)
     FOR Aptr := Psn TO Lnth-1 DO
       StrBuff[Aptr] := chr;
     END;
   END;  (* else truncate *)
   IF Lnth <= HIGH(StrBuff) THEN
     StrBuff[Lnth] := CHR(0);
   END;
 END PadStr;


 PROCEDURE OverWrite(VAR StrBuff:ARRAY OF CHAR; Psn:CARDINAL; Strng:ARRAY OF CHAR);  (* 04-16-99 *)
 VAR LTH,BLTH,APTR,CPT,OVLTH: CARDINAL;
 BEGIN
   IF Psn = 0 THEN Psn := 1; END;
   DEC(Psn);
   IF Psn > HIGH(StrBuff) THEN RETURN; END;
   LTH := Str.Length(Strng);
   IF LTH = 0 THEN RETURN; END;
   BLTH := Str.Length(StrBuff);
   IF Psn(*+1-1*) > BLTH THEN                              (* 04-16-99 *)
     PadStr(StrBuff,Psn(*+1-1*)," ");                      (* 04-16-99 *)
     BLTH := Psn(*+1-1*);                                  (* 04-16-99 *)
   END;
   OVLTH := HIGH(StrBuff)+1 - Psn; (*  max overwrite length  *)  (* 04-16-99 *)
   IF OVLTH >= LTH THEN OVLTH := LTH; (* ok *)
   ELSE LTH := OVLTH; END;   (* clip strng *)
   APTR := Psn;
  (* --------
   DEC(OVLTH);  (* Can't use BLTH-1 in FOR, Bug in compiler *)   (* 05-26-99 *)
   FOR CPT := 0 TO OVLTH DO                                (* 05-26-99 *)
   FOR CPT := 0 TO OVLTH-1 DO                              (* 04-29-99 *)
  ------- *)
   DEC(OVLTH);                                             (* 03-05-00 *)
   CPT := 0;                                               (* 03-05-00 *)
   LOOP
     IF CPT > OVLTH THEN EXIT; END;                       (* 03-05-00 *)
     StrBuff[APTR] := Strng[CPT];
     INC(APTR);
     INC(CPT);                                            (* 03-05-00 *)
   END; (* loop *)
   IF (BLTH(*-1+1*) <= APTR) AND (APTR <= HIGH(StrBuff)) THEN  (* 04-16-99 *)
     StrBuff[APTR] := CHR(0);                              (* 04-16-99 *)
   END;
 END OverWrite;


PROCEDURE Show(VAR W:ScWinDesc; X,Y:RelCoord; St:ARRAY OF CHAR);
  BEGIN
    WITH W DO
      CWRUN.Show( VAL(SIGNED,XF*(XA+X-1)+Hbdr), VAL(SIGNED,YF*(YA+Y-1)+Vbdr), St );  (* 04-30-99 *)
    END; (* with *)
  END Show;


PROCEDURE Blank(VAR W:ScWinDesc);
  BEGIN
    WITH W DO
      CWRUN.BLANK( VAL(SIGNED,XF*XA+Hbdr), VAL(SIGNED,YF*YA+Vbdr),            (* 05-13-99 *)
                     VAL(SIGNED,XF*(XB-XA+1)), VAL(SIGNED,YF*(YB-YA+1)+2) );  (* 05-13-99 *)
    END; (* with *)
  END Blank;


PROCEDURE BlankLn(VAR W:ScWinDesc; Ps, Ln, Lg:CARDINAL);                (* 05-07-99 *)
  VAR Bl: ARRAY[0..80] OF CHAR;
  BEGIN
    IF Lg = 0 THEN RETURN; END;                                         (* 05-13-99 *)
    WITH W DO
      IF Ln > Depth THEN RETURN; END;                                   (* 04-30-99 *)
      IF Ps > Width THEN RETURN; END;                                   (* 04-30-99 *)
      IF Lg > (Width - Ps) THEN Lg := Width - Ps; END;                  (* 04-30-99 *)
      CWRUN.BLANK( VAL(SIGNED,XF*(XA+Ps-1)+Hbdr), VAL(SIGNED,YF*(YA+Ln-1)+1+Vbdr),  (* 05-13-99 *)
                     VAL(SIGNED,XF*(Lg+1)), VAL(SIGNED,YF) );           (* 05-13-99 *)
    END; (* with *)
  END BlankLn;


PROCEDURE Refresh(VAR W:ScWinDesc);
  VAR Xline,Xptr: CARDINAL;
  BEGIN
    WITH W DO
      (* Clear screen and repaint. *)
      Blank(W);
      Xptr := TTYptr;
      FOR Xline := 1 TO Depth DO
        Xptr := (Xptr + 1) MOD Depth;                    (* 05-13-99 *)
        Show(W, 1, Xline, TTYstring[Xptr] );             (* 05-13-99 *)
      END;
    END; (* with *)
  END Refresh;


PROCEDURE Clear(VAR W:ScWinDesc);
  VAR Xptr: CARDINAL;  (* index to string to display *)
  BEGIN
    WITH W DO
      (* Clear array of strings. *)
      FOR Xptr := 0 TO ScreenDepth-1 DO                          (* 03-05-00 *)
        TTYstring[Xptr] := "";                                   (* 03-05-00 *)
      END;
      TTYptr := Depth-1;                                       (* 05-13-99 *)
      CurrentY := 1;
      CurrentX := 1;
    END; (* with *)     (* 05-06-99 *)
  END Clear;


PROCEDURE Open(VAR W:ScWinDesc; X1, Y1, X2, Y2:AbsCoord);      (* 05-07-99 *)
  BEGIN						(* 07-14-00 *)
    WITH W DO
      XA := X1; YA := Y1; XB := X2; YB := Y2;
      IF XB > ScreenWidth-1 THEN XB := ScreenWidth-1; END;  (* 05-10-99 *)
      IF YB > ScreenDepth-1 THEN YB := ScreenDepth-1; END;  (* 05-10-99 *)
      Width := X2-X1+1; Depth := Y2-Y1+1;
      XF := Xfontsize;                                    (* 05-06-99 *)
      YF := Yfontsize;                                    (* 05-06-99 *)
      Clear(W);
    END; (* with *)
  END Open;



PROCEDURE ArrayLine(VAR W:ScWinDesc; Yc:CARDINAL): CARDINAL;     (* 05-12-99 *)
  VAR Ar: CARDINAL;
  BEGIN
    WITH W DO
      Ar := (TTYptr + Yc) MOD Depth;               (* 05-13-99 *)
    END; (* with *)
    RETURN Ar;                                     (* 05-13-99 *)
  END ArrayLine;



PROCEDURE GoToXY(VAR W:ScWinDesc; Xc,Yc:CARDINAL);
  BEGIN					(* 07-14-00 *)
    WITH W DO
      IF Xc > Width THEN CurrentX := Width;            (* 04-30-99 *)
      ELSE CurrentX := Xc; END;
      IF Yc > Depth THEN CurrentY := Depth;
      ELSE CurrentY := Yc; END;
      IF CurrentX = 0 THEN CurrentX := 1; END;
      IF CurrentY = 0 THEN CurrentY := 1; END;
    END; (* with *)                                    (* 05-13-99 *)
  END GoToXY;



PROCEDURE WrLn(VAR W:ScWinDesc);
  BEGIN
   (* Implement a non-rippling circular buffer. *)
    WITH W DO
      CurrentX := 1;
      IF CurrentY >= Depth THEN  (* scroll *)
        CurrentY := Depth;                            (* 04-30-99 *)
        TTYptr := (TTYptr + 1) MOD Depth;               (* 05-13-99 *)
        TTYstring[TTYptr] := '';                        (* 05-13-99 *)
        (* Clear screen and repaint with scroll. *)
        Refresh(W);
      ELSE
        (* Go to next line *)
        INC(CurrentY);
      END;
    END; (* with *)
  END WrLn;








PROCEDURE WrStr(VAR W:ScWinDesc; St:ARRAY OF CHAR; WrapOn,Hide:BOOLEAN);     (* 05-12-99 *)
  CONST  cr = CHR(13);  lf = CHR(10);  bel = CHR(7);
  VAR Xstr: ARRAY[0..81] OF CHAR;  Xlen, XS, XR, CurX: CARDINAL;      (* 06-04-99 *)


  PROCEDURE WrXstr();                                                   (* 05-12-99 *)
    VAR Aptr: CARDINAL;
    BEGIN
      IF XS <= HIGH(Xstr) THEN Xstr[XS] := CHR(0); END;               (* 06-04-99 *)
      IF XS = 0 THEN RETURN; END;                                   (* 05-13-99 *)
      WITH W DO
        IF CurrentX <= Width THEN                                     (* 06-29-99 *)
          Aptr := ArrayLine(W, CurrentY);                             (* 05-12-99 *)
          OverWrite(TTYstring[Aptr], CurrentX, Xstr); (* write string over line *)  (* 05-13-99 *)
          IF Width < ScreenWidth THEN                                 (* 06-04-99 *)
            TTYstring[Aptr][Width(*-1+1*)] := CHR(0); (* truncate *)  (* 05-13-99 *)
          END;
          IF NOT Hide THEN                                          (* 05-07-99 *)
            BlankLn(W, CurrentX, CurrentY, XS);                     (* 05-07-99 *)
            Show(W, CurrentX, CurrentY, Xstr);                      (* 05-07-99 *)
          END;
          INC(CurrentX, XS);
        END;
      END; (* with *)
      XS := 0;                                              (* 06-04-99 *)
      Xstr := "";                                           (* 06-04-99 *)
    END WrXstr;

  BEGIN    (* WrStr *)
    Xlen := Str.Length(St);                                           (* 05-12-99 *)
    IF Xlen = 0 THEN RETURN; END;                                     (* 05-12-99 *)
    XS := 0;  XR := 0;                                                (* 05-26-99 *)
    Xstr := "";
    WITH W DO
      LOOP
        IF St[XR] = cr THEN
          WrXstr();                                                    (* 05-03-00 *)
          CurrentX := 1;  (* Return cursor to beginning of line *)     (* 05-12-99 *)
        ELSIF St[XR] = lf THEN
          WrXstr();                                                    (* 05-03-00 *)
          CurX := CurrentX;                                            (* 05-12-99 *)
          WrLn(W);     (* Write next line *)                           (* 05-12-99 *)
          GoToXY(W,CurX,CurrentY);                                     (* 05-26-99 *)
        ELSIF St[XR] = bel THEN
          CWRUN.BEEP(150, CWRUN.BEEPHand);                             (* 06-10-99 *)
        ELSIF St[XR] < " " THEN                                        (* 04-14-99 *)
          Xstr[XS] := " "; INC(XS);                                    (* 05-12-99 *)
        ELSE
          Xstr[XS] := St[XR]; INC(XS);
        END;
        IF WrapOn AND ((CurrentX + XS) > Width) THEN                   (* 05-26-99 *)
          WrXstr();                                                    (* 05-03-00 *)
          WrLn(W);     (* Write next line *)                           (* 05-12-99 *)
        END;
        INC(XR);
        IF XR > Xlen-1 THEN                                            (* 05-26-99 *)
          WrXstr();                                                    (* 05-03-00 *)
          EXIT;
        ELSIF XS > HIGH(Xstr) THEN                                     (* 05-26-99 *)
          WrXstr();                                                    (* 05-03-00 *)
        END;
      END; (* loop *)
    END; (* with *)
  END WrStr;




(* No init *)
END M2SCROLL.
