(* ------------------------------------------------------------ *)
(* ---                    TTYMTEST.DEF                      --- *)
(* ---   Interface to Clarion scrolling screen functions.   --- *)
(* ---   This version is for Clarion for Windows V5.0a      --- *)
(* ---   Uses the currently top window in thread.           --- *)
(* ---                                                      --- *)
(* ---   Version 1.02    Last modified by  CWS  06-10-99    --- *)
(* ------------------------------------------------------------ *)


(*#module(init_code => off) *)
(*#call (o_a_copy=>off)*)
IMPLEMENTATION MODULE TTYMTEST;


IMPORT Str, Lib, CWRUN;

FROM M2SCROLL IMPORT
  ScreenWidth, ScreenDepth, ScWinDesc,
  Refresh, Clear, Open, GoToXY, WrStr, WrLn;


CONST
  FHeight = 11;
  FWidth = 31;
  Bstr = "12345678901234567890123456789012345678901234567890123456789012345678901234567890";
  Fstr = "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%";     (* 04-30-99 *)

VAR
  WBack: ScWinDesc;
  WFront: ScWinDesc;

VAR
  VAR IxB, IxF: CARDINAL;


 PROCEDURE OpenB;
  BEGIN
    IxB := 0;
    Open(WBack, 0,0, ScreenWidth-1,ScreenDepth-1);    (* 05-10-99 *)
    FillScrB;
  END OpenB;


 PROCEDURE OpenF;
  BEGIN
    IxF := 0;
    Open(WFront, 19, 4, 49, 14);            (* 05-10-99 *)
    FillScrF;
  END OpenF;


(* PROCEDURE ClearB; *)


 PROCEDURE ClearF;
  BEGIN
    Clear(WFront);
    Refresh(WFront);                          (* 05-10-99 *)
  END ClearF;


 PROCEDURE FillScrB;
  VAR Ix: CARDINAL;
  BEGIN
    GoToXY(WBack,1,1);
    FOR Ix := 1 TO ScreenDepth DO
      WrStr(WBack,Bstr,FALSE,FALSE);
      IF Ix < ScreenDepth THEN
        WrLn(WBack);
      END;
    END;
  END FillScrB;


 PROCEDURE FillScrF;
  VAR Ix: CARDINAL;
  BEGIN
    GoToXY(WFront,1,1);
    FOR Ix := 1 TO FHeight DO
      WrStr(WFront,Fstr,FALSE,FALSE);
      IF Ix < FHeight THEN
        WrLn(WFront);
      END;
    END;
  END FillScrF;



 PROCEDURE WriteB;
  VAR Stx: ARRAY[0..4] OF CHAR;  ok: BOOLEAN;
  BEGIN
    INC(IxB);
    Str.CardToStr(VAL(LONGCARD,IxB), Stx, 10, ok);
    WrStr(WBack, "== ",FALSE,FALSE);
    WrStr(WBack, Stx,FALSE,FALSE);
    WrStr(WBack, " ==================================================================",FALSE,FALSE);
    WrLn(WBack);
  END WriteB;


 PROCEDURE WriteF;
  VAR Stx: ARRAY[0..4] OF CHAR;  ok: BOOLEAN;
      Ix: CARDINAL;  Xch: CHAR;
  BEGIN
    INC(IxF);
    Str.CardToStr(VAL(LONGCARD,IxF), Stx, 10, ok);
    WrStr(WFront, "++ ",FALSE,FALSE);
    WrStr(WFront, Stx,FALSE,FALSE);
    WrStr(WFront, " +++ ",FALSE,FALSE);                 (* 05-10-99 *)
    FOR Ix := 1 TO 10 DO                        (* 05-10-99 *)
      Xch := CHR( (IxF * 10) + Ix );              (* 05-10-99 *)
      IF (Xch = CHR(13)) OR (Xch = CHR(10)) OR (Xch = CHR(9)) THEN Xch := " "; END; (* 05-10-99 *)
      WrStr(WFront, Xch,FALSE,FALSE);                   (* 05-10-99 *)
    END;
    WrStr(WFront, " +++++++++",FALSE,FALSE);
    WrLn(WFront);
  END WriteF;





END TTYMTEST.
